/*
 * bin2c : converts stdin to a C string variable
 * version 0.0.1 - 2004/12/14 - willy tarreau
 */

#include <stdio.h>

int main(int argc, char **argv) {
    enum {
	INIT=0,
	MID,
	RIGHT
    } state = INIT;
    
    int c, size;
    char *varname;

    if (argc > 1)
	varname = argv[1];
    else
	varname = "image";

    printf("const unsigned char %s[] =", varname);
    state = INIT;
    size = 0;

    while ((c = getchar()) != EOF) {
	if (state == INIT) {
	    printf("\n\t\"");
	}

	switch (state) {
	case RIGHT:
	    printf("\n\t\""); /* no break */
	case MID:
	case INIT:
	    state = MID;
	    printf("\\x%02x", c);
	    if ((++size & 15) != 0)
		break;
	    putchar('"');
	    state = RIGHT;
	}
    }

    switch (state) {
    case INIT:
	putchar(' ');
	putchar('"'); /* no break */
    case MID:
	putchar('"'); /* no break */
    case RIGHT:
	putchar(';'); /* no break */
    }
    printf("\nconst int %s_size = %d;\n\n", varname, size);
    return 0;
}
